Compare commits

...

10 Commits

Author SHA1 Message Date
Suzanne Soy
68db618570 Merge branch 'screenshot-full-length-firefox' into 'master'
take full-length screenshots of pages using firefox

See merge request suzanne.soy/web-client!4
2020-10-14 01:38:29 +00:00
suzanne.soy
a19996ff74 take full-length screenshots of pages using firefox 2020-10-10 02:46:58 +01:00
Suzanne Soy
abdc5f34c6 Merge branch 'export-firefox-bookmarksbackup' into 'master'
Export bookmarksbackup from firefox

See merge request suzanne.soy/web-client!3
2020-10-10 01:42:53 +00:00
Suzanne Soy
cbd1d384ff Merge branch 'master' into 'export-firefox-bookmarksbackup'
# Conflicts:
#   export-firefox-tabs.sh
2020-10-10 01:36:05 +00:00
Suzanne Soy
f73cb26a4e Merge branch 'error-handling-and-nix' into 'master'
More error handling and use nix to bring in the dependencies

See merge request suzanne.soy/web-client!2
2020-10-10 01:35:30 +00:00
Suzanne Soy
a1bb152ee4 Merge branch 'export-firefox-tabs' into 'master'
Export of firefox tabs

See merge request suzanne.soy/web-client!1
2020-10-10 01:35:16 +00:00
suzanne.soy
bc1c54af82 Export bookmarksbackup from firefox 2020-10-09 06:08:49 +01:00
suzanne.soy
1b3c5871a2 Export of firefox tabs 2020-10-09 05:36:28 +01:00
suzanne.soy
7632c673fa more error handling and use nix to bring in the dependencies 2020-10-09 05:26:11 +01:00
suzanne.soy
078652e118 Draft script to export Chromium's bookmarks 2020-09-27 18:39:22 +01:00
8 changed files with 124 additions and 0 deletions

1
.gitignore vendored Normal file
View File

@ -0,0 +1 @@
/tests-results/

16
export-chrome-bookmarks.sh Executable file
View File

@ -0,0 +1,16 @@
#!/usr/bin/env nix-shell
#!nix-shell --pure -i bash -p dejsonlz4 jq bash -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
# Usage: ./export-firefox-bookmarks.sh [path/to/.mozilla/firefox/XXXXXXXX.profile]
set -euET -o pipefail
if test $# -ge 1; then
profile="$1"
else
# use printf to avoid echo's ambiguity; save trailing whitespace with a dummy x (not needed here as the string ends with "Default", but a good habit nevertheless)
profile="$(printf "%sx" ~/.config/chromium/Default/)"
profile="${profile%x}"
fi
jq '.roots[] | recurse(.children?[]?) | "\( .name? ): \( .url? )"' < "$profile"/Bookmarks

View File

@ -0,0 +1,23 @@
#!/usr/bin/env nix-shell
#!nix-shell --pure -i bash -p dejsonlz4 jq bash -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
# Usage: ./export-firefox-bookmarks.sh [path/to/.mozilla/firefox/XXXXXXXX.profile]
set -euET -o pipefail
if test $# -ge 1; then
profile="$1"
else
# use printf to avoid echo's ambiguity; sort for determinism; use null separator (only byte illegal in UNIX paths, save trailing whitespace with a dummy x (not needed here as the string ends with "default", but a good habit nonetheless)
profile="$(printf "%s"\\0 ~/.mozilla/firefox/*.default | sort -z | head -z -n 1 | tr -d \\0; printf "x")"
profile="${profile%x}"
fi
# use printf to avoid echo's ambiguity; sort to get latest backup; use null separator (only byte illegal in UNIX paths, save trailing whitespace with a dummy x (not neede here as the string ends with ".jsonlz4" but a good habit nonetheless)
js="$(printf "%s"\\0 "$profile"/bookmarkbackups/bookmarks-*.jsonlz4 | sort -z --general-numeric-sort | tail -z -n 1 | tr -d \\0; printf "x")"
js="${js%x}"
# TODO: filter out entries whose uri is null after checking that they're not important
# TODO: add folder structure to give a path for each bookmark
dejsonlz4 "$js" | jq 'recurse(.children?[]?) | "\( .title? ): \( .uri? )"'

29
export-firefox-tabs.sh Executable file
View File

@ -0,0 +1,29 @@
#!/usr/bin/env nix-shell
#!nix-shell --pure -i bash -p dejsonlz4 jq bash -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
# Usage: ./export-firefox-bookmarks.sh [path/to/.mozilla/firefox/XXXXXXXX.profile]
set -euET -o pipefail
if test $# -ge 1; then
profile="$1"
else
# use printf to avoid echo's ambiguity; sort for determinism; use null separator (only byte illegal in UNIX paths, save trailing whitespace with a dummy x (not needed here as the string ends with "default", but a good habit nevertheless)
profile="$(printf "%s"\\0 ~/.mozilla/firefox/*.default | sort -z | head -z -n 1 | tr -d \\0; printf "x")"
profile="${profile%x}"
fi
if test -e "$profile"/sessionstore-backups/recovery.jsonlz4; then
sessionstore="$profile"/sessionstore-backups/recovery.jsonlz4
elif test -e "$profile"/sessionstore.jsonlz4; then
sessionstore="$profile"/sessionstore.jsonlz4
elif test -e "$profile"/sessionstore.js; then
sessionstore="$profile"/sessionstore.js
else
printf "Could not find session store at $profile/sessionstore-backups/recovery.jsonlz4 or $profile/sessionstore.jsonlz4 or $profile/sessionstore.js"
exit 1
fi
# TODO: when the name is sessionstore.js, it might not need a decompression with dejsonlz4 ?
# Tabs from all windows are printed together, edit the jq expression to your needs. The input format is described at https://wiki.mozilla.org/Firefox/session_restore#For_developers
dejsonlz4 "$sessionstore" | jq '.windows[].tabs[].entries[-1].url'

View File

@ -0,0 +1,8 @@
#!/bin/bash
set -euET -o pipefail
echo "This is just an example, best not to depend on the user having the panorama plug-in installed."
exit 1.
dejsonlz4 ~suzanne/apps/chromium/.mozilla/firefox/*.default/sessionstore-backups/recovery.jsonlz4 | jq '.windows[0].tabs[]|.extData["extension:panorama-tab-groups@example.com:thumbnail"]' -r | jq '.thumbnail'

29
screenshot-full-firefox.sh Executable file
View File

@ -0,0 +1,29 @@
#!/usr/bin/env nix-shell
#!nix-shell --pure -i bash -p firefox-esr bash -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
set -euET -o pipefail
usage() {
printf "Usage: ./screenshot-full-firefox.sh url filename"\\n
}
if test $# -ne 2; then
usage
exit 1
elif test $# -eq 1 && (test "x$1" = "x-h" || test "x$1" = "x--help"); then
usage
exit 0
fi
url="$1"
image="$2"
temp_profile_home="$(mktemp -d)"
function cleanup() {
rm -fr --one-file-system "$temp_profile_home"
}
trap cleanup EXIT
HOME="$temp_profile_home" firefox --headless --window-size 1920 --screenshot "$image" "$url"

11
tests.sh Executable file
View File

@ -0,0 +1,11 @@
#!/usr/bin/env nix-shell
#!nix-shell -i bash -p bash nix -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
# Older nix-shell --pure versions prevent nested nix-shells to properly download dependencies, so the above doesn't use --pure.
# If this script increases in complexity and becomes more sensitive to env vars, use --pure and wrap it with an impure launcher.
set -euET -o pipefail
for i in tests/*.sh; do
"$i"
done

View File

@ -0,0 +1,7 @@
#!/usr/bin/env nix-shell
#!nix-shell --pure -i bash -p bash nix -I nixpkgs=https://github.com/NixOS/nixpkgs/archive/fea633695211167753ee732c9087808d0c57461c.tar.gz
set -euET -o pipefail
cd "$(dirname "$0")"
../screenshot-full-firefox.sh https://example.com/ ../tests-results/screenshots-full-firefox.png